package org.jsonddl.model;
/**
   * A model represents a single kind of object within the schema. There is a
   * 1:1 correspondence between Models and Java classes or JS type closures.
   */
@javax.annotation.Generated(value="org.jsonddl.generator.industrial.IndustrialDialect", date="2011-12-14T07:55:55")
public interface Model extends org.jsonddl.JsonDdlObject<Model> {
java.lang.String getComment();
/**
     * A two-level map that breaks out per-dialect properties to be consumed by
     * the dialect code-generators.
     */
java.util.Map<java.lang.String,java.util.Map<java.lang.String,java.lang.String>> getDialectProperties();
java.util.List<EnumValue> getEnumValues();
java.lang.String getName();
java.util.List<Property> getProperties();
public static class Builder  implements org.jsonddl.JsonDdlObject.Builder<Model>, org.jsonddl.impl.Traversable<Model>, org.jsonddl.impl.Digested, Model {
private ModelImpl obj;
public Builder() {this(new ModelImpl());}
Builder(ModelImpl instance) {this.obj = instance;}
public Model.Builder builder() { return this; }
public Class<Model> getDdlObjectType() { return Model.class;}
public Model.Builder newInstance() { return new Model.Builder(); }
public java.util.Map<String, Object> toJsonObject() { return obj.toJsonObject(); }
public byte[] computeDigest() {
byte[] digest;
org.jsonddl.impl.DigestVisitor v = new org.jsonddl.impl.DigestVisitor(); accept(v); digest = v.getDigest();
return digest;
}
public int hashCode() {
byte[] digest = computeDigest();
return (int)((digest[0] << 3) | (digest[1] << 2) | (digest[18] << 1) | digest[19]);
}
public boolean equals(Object o) {
if (o == this) { return true; }
if (!(o instanceof org.jsonddl.impl.Digested)) { return false; }
byte[] d1 = computeDigest(); byte[] d2 = ((org.jsonddl.impl.Digested)o).computeDigest();
for (int i = 0, j = d1.length; i<j; i++) { if (d1[i] != d2[i]) return false ;}
return true;
}
/** For debugging use only. */
public String toString() {
return org.jsonddl.impl.JsonMapVisitor.toString(this);
}
public java.lang.String getComment() { return obj.Comment; }
public void setComment(java.lang.String value) { withComment(value);}
public Model.Builder withComment(java.lang.String value) { obj.Comment = value;return this;}
public java.util.Map<java.lang.String,java.util.Map<java.lang.String,java.lang.String>> getDialectProperties() { return obj.DialectProperties; }
/**
     * A two-level map that breaks out per-dialect properties to be consumed by
     * the dialect code-generators.
     */
public void setDialectProperties(java.util.Map<java.lang.String,java.util.Map<java.lang.String,java.lang.String>> value) { withDialectProperties(value);}
/**
     * A two-level map that breaks out per-dialect properties to be consumed by
     * the dialect code-generators.
     */
public Model.Builder withDialectProperties(java.util.Map<java.lang.String,java.util.Map<java.lang.String,java.lang.String>> value) { obj.DialectProperties = value;return this;}
public Model.Builder putDialectProperties(java.lang.String key,java.util.Map<java.lang.String,java.lang.String> value) {
if (obj.DialectProperties == null) { obj.DialectProperties = new java.util.LinkedHashMap(); }
obj.DialectProperties.put(key, value);
return this;
}
public java.util.List<EnumValue> getEnumValues() { return obj.EnumValues; }
public void setEnumValues(java.util.List<EnumValue> value) { withEnumValues(value);}
public Model.Builder withEnumValues(java.util.List<EnumValue> value) { obj.EnumValues = value;return this;}
public Model.Builder addEnumValues(EnumValue element) {
if (obj.EnumValues == null) { obj.EnumValues = new java.util.ArrayList(); }
obj.EnumValues.add(element);
return this;
}
public java.lang.String getName() { return obj.Name; }
public void setName(java.lang.String value) { withName(value);}
public Model.Builder withName(java.lang.String value) { obj.Name = value;return this;}
public java.util.List<Property> getProperties() { return obj.Properties; }
public void setProperties(java.util.List<Property> value) { withProperties(value);}
public Model.Builder withProperties(java.util.List<Property> value) { obj.Properties = value;return this;}
public Model.Builder addProperties(Property element) {
if (obj.Properties == null) { obj.Properties = new java.util.ArrayList(); }
obj.Properties.add(element);
return this;
}
public Model.Builder accept(org.jsonddl.JsonDdlVisitor visitor) {
obj = new org.jsonddl.impl.ContextImpl.ObjectContext.Builder<Model>().withValue(this).withKind(org.jsonddl.model.Kind.DDL).withMutability(true).build().traverse(visitor).builder().obj;
return this;
}
public Model build() {
ModelImpl toReturn = obj;
obj = null;
toReturn.DialectProperties = org.jsonddl.impl.Protected.object(toReturn.DialectProperties);
toReturn.EnumValues = org.jsonddl.impl.Protected.object(toReturn.EnumValues);
toReturn.Properties = org.jsonddl.impl.Protected.object(toReturn.Properties);
return toReturn;
}
public Model.Builder from(Model from) {
withComment(from.getComment());
withDialectProperties(from.getDialectProperties());
withEnumValues(from.getEnumValues());
withName(from.getName());
withProperties(from.getProperties());
return this;}
public Model.Builder from(java.util.Map<String, Object> map){
accept(org.jsonddl.impl.JsonMapVisitor.fromJsonMap(map));
return this;
}
public Model.Builder traverse(org.jsonddl.JsonDdlVisitor visitor) {
withComment(
new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.lang.String>()
.withKind(org.jsonddl.model.Kind.STRING)
.withLeafType(java.lang.String.class)
.withMutability(true)
.withProperty("comment")
.withValue(obj.Comment)
.build().traverse(visitor));
withDialectProperties(
new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.util.Map<java.lang.String,java.util.Map<java.lang.String,java.lang.String>>>()
.withKind(org.jsonddl.model.Kind.MAP)
.withNestedKinds(java.util.Arrays.asList(org.jsonddl.model.Kind.STRING, org.jsonddl.model.Kind.MAP, org.jsonddl.model.Kind.STRING, org.jsonddl.model.Kind.STRING))
.withLeafType(java.lang.String.class)
.withMutability(true)
.withProperty("dialectProperties")
.withValue(obj.DialectProperties)
.build().traverse(visitor));
withEnumValues(
new org.jsonddl.impl.ContextImpl.ListContext.Builder<EnumValue>()
.withKind(org.jsonddl.model.Kind.LIST)
.withNestedKinds(java.util.Arrays.asList(org.jsonddl.model.Kind.DDL))
.withLeafType(EnumValue.class)
.withMutability(true)
.withProperty("enumValues")
.withValue(obj.EnumValues)
.build().traverse(visitor));
withName(
new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.lang.String>()
.withKind(org.jsonddl.model.Kind.STRING)
.withLeafType(java.lang.String.class)
.withMutability(true)
.withProperty("name")
.withValue(obj.Name)
.build().traverse(visitor));
withProperties(
new org.jsonddl.impl.ContextImpl.ListContext.Builder<Property>()
.withKind(org.jsonddl.model.Kind.LIST)
.withNestedKinds(java.util.Arrays.asList(org.jsonddl.model.Kind.DDL))
.withLeafType(Property.class)
.withMutability(true)
.withProperty("properties")
.withValue(obj.Properties)
.build().traverse(visitor));
return this;
}
}
Builder builder();
Builder newInstance();
}
